#import <Foundation/Foundation.h>
#import "SWGDeposit.h"
#import "SWGDepositCompleteResponse.h"
#import "SWGDepositTransferResponse.h"
#import "SWGError.h"
#import "SWGApi.h"

/**
* Upbit Open API
* ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
*
* OpenAPI spec version: 1.0.0
* Contact: ujhin942@gmail.com
*
* NOTE: This class is auto generated by the swagger code generator program.
* https://github.com/swagger-api/swagger-codegen.git
* Do not edit the class manually.
*/



@interface SWGDepositApi: NSObject <SWGApi>

extern NSString* kSWGDepositApiErrorDomain;
extern NSInteger kSWGDepositApiMissingParamErrorCode;

-(instancetype) initWithApiClient:(SWGApiClient *)apiClient NS_DESIGNATED_INITIALIZER;

/// 개별 입금 주소 조회
/// ## 개별 입금 주소 조회 **NOTE**: 입금 주소 조회 요청 API 유의사항 입금 주소 생성 요청 이후 아직 발급되지 않은 상태일 경우 deposit_address가 null일 수 있습니다. 
///
/// @param currency Currency symbol 
/// 
///  code:200 message:"OK",
///  code:400 message:"Bad Request",
///  code:401 message:"Unauthorized",
///  code:403 message:"Forbidden",
///  code:404 message:"Not Found",
///  code:500 message:"Internal Server Error"
///
/// @return SWGDepositCompleteResponse*
-(NSURLSessionTask*) depositCoinAddressWithCurrency: (NSString*) currency
    completionHandler: (void (^)(SWGDepositCompleteResponse* output, NSError* error)) handler;


/// 전체 입금 주소 조회
/// ## 내가 보유한 자산 리스트를 보여줍니다. **NOTE**: 입금 주소 조회 요청 API 유의사항 입금 주소 생성 요청 이후 아직 발급되지 않은 상태일 경우 deposit_address가 null일 수 있습니다. 
///
/// 
///  code:200 message:"OK",
///  code:400 message:"Bad Request",
///  code:401 message:"Unauthorized",
///  code:403 message:"Forbidden",
///  code:404 message:"Not Found",
///  code:500 message:"Internal Server Error"
///
/// @return NSObject*
-(NSURLSessionTask*) depositCoinAddressesWithCompletionHandler: 
    (void (^)(NSObject* output, NSError* error)) handler;


/// 입금 주소 생성 요청
/// 입금 주소 생성을 요청한다. **NOTE**: 입금 주소 생성 요청 API 유의사항 입금 주소의 생성은 서버에서 비동기적으로 이뤄집니다. 비동기적 생성 특성상 요청과 동시에 입금 주소가 발급되지 않을 수 있습니다. 주소 발급 요청 시 결과로 Response1이 반환되며 주소 발급 완료 이전까지 계속 Response1이 반환됩니다. 주소가 발급된 이후부터는 새로운 주소가 발급되는 것이 아닌 이전에 발급된 주소가 Response2 형태로 반환됩니다. 정상적으로 주소가 생성되지 않는다면 일정 시간 이후 해당 API를 다시 호출해주시길 부탁드립니다. 
///
/// @param currency Currency 코드 
/// 
///  code:200 message:"OK",
///  code:201 message:"Create",
///  code:400 message:"Bad Request",
///  code:401 message:"Unauthorized",
///  code:403 message:"Forbidden",
///  code:404 message:"Not Found",
///  code:500 message:"Internal Server Error"
///
/// @return SWGDepositCompleteResponse*
-(NSURLSessionTask*) depositGenerateCoinAddressWithCurrency: (NSString*) currency
    completionHandler: (void (^)(SWGDepositCompleteResponse* output, NSError* error)) handler;


/// 개별 입금 조회
/// ## 개별 입금 조회 
///
/// @param uuid 입금 UUID  (optional)
/// @param txid 입금 TXID  (optional)
/// @param currency Currency 코드  (optional)
/// 
///  code:200 message:"OK",
///  code:400 message:"Bad Request",
///  code:401 message:"Unauthorized",
///  code:403 message:"Forbidden",
///  code:404 message:"Not Found",
///  code:500 message:"Internal Server Error"
///
/// @return SWGDeposit*
-(NSURLSessionTask*) depositInfoWithUuid: (NSString*) uuid
    txid: (NSString*) txid
    currency: (NSString*) currency
    completionHandler: (void (^)(SWGDeposit* output, NSError* error)) handler;


/// 입금 리스트 조회
/// ## 입금 리스트 조회 
///
/// @param currency Currency 코드  (optional)
/// @param state 출금 상태 - submitting : 처리 중 - submitted : 처리완료 - almost_accepted : 입금 대기 중 - rejected : 거절 - accepted : 승인됨 - processing : 처리 중  (optional)
/// @param uuids 입금 UUID의 목록  (optional)
/// @param txids 입금 TXID의 목록  (optional)
/// @param limit 개수 제한 (default: 100, max: 100)  (optional)
/// @param page 페이지 수, default: 1  (optional)
/// @param orderBy 정렬 방식 - asc : 오름차순 - desc : 내림차순 (default)  (optional)
/// 
///  code:200 message:"OK",
///  code:400 message:"Bad Request",
///  code:401 message:"Unauthorized",
///  code:403 message:"Forbidden",
///  code:404 message:"Not Found",
///  code:500 message:"Internal Server Error"
///
/// @return NSArray<SWGDeposit>*
-(NSURLSessionTask*) depositInfoAllWithCurrency: (NSString*) currency
    state: (NSString*) state
    uuids: (NSArray<NSString*>*) uuids
    txids: (NSArray<NSString*>*) txids
    limit: (NSNumber*) limit
    page: (NSNumber*) page
    orderBy: (NSString*) orderBy
    completionHandler: (void (^)(NSArray<SWGDeposit>* output, NSError* error)) handler;



@end
